#pragma once

#include "defs.h"

const int MAXSC = 1000; // limit

struct SC 
{
	int N;
	int exp[MAXSC]; // exponents
	ex coef;
	ex base;
	int order() { int sum=0; for (int i=0;i<N;i++) sum+=exp[i]; return sum; }
	void init(int iN)
	{ 
		N=iN;
		if (N>=MAXSC) printf("error: MAXSC %d exceeded %d\n",MAXSC, N);
		for (int i=0;i<N;i++) exp[i]=0; 
	}
};


struct COEFS 
{
	std::vector<SC> v;
	std::vector<ex> basis;
	std::vector<ex> basis_tex;
	std::vector<int> pow_dl;
	std::vector<int> pow_dt;
	int order=6; // default
	void fill(ex &e);
	bool fill_recursive(ex &e, SC &sc, int level);
	ex check(ex &e);
	// adds another COEFS to this
	void add(COEFS &CF2);
	// copy basis
	void copy_basis(COEFS &CF2);
	// compare exp[] for two SCs 
	bool compare(SC&sc1, SC&sc2);
};
